lib = File.expand_path('../../lib', __FILE__)

$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

ENV['ENV'] ||= (ENV['RAILS_ENV'] || ENV['RACK_ENV'] || 'development')

require 'dotenv'

Dotenv.overload \
  File.expand_path('../.env', __FILE__),
  File.expand_path("../.env_#{ENV['ENV']}", __FILE__)

require 'dash_overlord'

DashOverlord::V1.configure do |config|
  config.set(:env, ENV.fetch('ENV'))
  config.set(:db_config, ENV.fetch('DASH_OVERLORD_V1_DATABASE_URL'))
end

DashOverlord::Models::V1::Base.establish_connection \
  DashOverlord::V1::Config.get(:db_config)

Dir[File.expand_path('../initializers/**{,/*/**}/*.rb', __FILE__)].each do |f|
  require f
end
