class CreateChartConfigs < ActiveRecord::Migration[5.0]
  def change
    create_table :chart_configs do |t|
      t.integer :project_id
      t.string :source, default: ''
      t.string :function, default: ''
      t.string :title, default: ''
      t.integer :title_font_size, default: 14
      t.string :title_font_style, default: 'normal'

      t.string :function_axis_title, default: 'Values'
      t.integer :function_axis_font_size, default: 12
      t.string :function_axis_font_style, default: 'normal'
      t.boolean :function_axis_auto_adjust, default: true
      t.integer :function_axis_maximum
      t.integer :function_axis_minimum, default: 0
      t.boolean :function_axis_interval_auto_adjust, default: true
      t.integer :function_axis_interval

      t.integer :function_axis_labels_font_size, default: 12
      t.integer :function_axis_labels_decimal_places
      t.string :function_axis_labels_font_style, default: 'normal'
      t.boolean :function_axis_labels_show, default: true

      t.string :source_axis_options_order, array: true, default: []
      t.boolean :source_axis_options_show, default: true
      t.integer :source_axis_font_size, default: 12
      t.string :source_axis_font_style, default: 'normal'
      t.jsonb  :cached_answer_values, default: []
      t.datetime :cached_answer_updated_at
    end

    add_index :chart_configs, :source_axis_options_order, using: 'gin'
  end
end
