module DashOverlord
  module Configure
    def configure
      yield(self::Config)
    end
  end

  module Config
    def set(key, value)
      data[key] = value
    end

    def get(key)
      return data[key] if data.key?(key)

      ENV.fetch(key.to_s.upcase, ENV.fetch("#{@prefix}#{key.to_s.upcase}"))
    end

    protected ########################## PROTECTED ############################

    def prefix(value)
      @prefix = value
    end

    def data
      @data ||= {}
    end
  end

  module V1
    extend DashOverlord::Configure

    module Config
      extend DashOverlord::Config

      prefix 'DASH_OVERLORD_V1_'
    end
  end
end
