require 'bcrypt'

module DashOverlord
  module Models
    module V1

      class BasicUser < V1::Base
        self.abstract_class = true

        include BCrypt

        attr_accessor :password
        attr_accessor :password_confirmation

        def secured_password
          return nil unless encrypted_password

          @password ||= Password.new(encrypted_password)
        end

        def secured_password=(new_password)
          @password = Password.create(new_password)

          self.encrypted_password = @password
        end

        def password_recovery_still_valid?
          true
        end
      end

    end
  end
end
