module DashOverlord
  module Models
    module V1

      class BeeVideo < V1::Base
        attr_accessor :meta

        has_many :subtitle_lines

        ransacker :cuisine do |parent|
          Arel::Nodes::InfixOperation.new \
            '->>', parent.table[:extra], Arel::Nodes.build_quoted('cuisine')
        end

        def title
          if segment_uid == 'world_cuisine'
            "#{country}, #{category} - #{cuisine}"
          else
            "#{country}, #{category}"
          end
        end

        def cuisine
          (extra || {})['cuisine']
        end
      end

    end
  end
end
