module DashOverlord
  module Models
    module V1

      class ChartConfig < V1::Base
        ALLOWED_FONT_STYLES = %w(normal italic bold).freeze

        ALLOWED_FUNCTIONS = %w(percentage count).freeze

        def self.allowed_sources(project_id)
          return [] unless project_id

          # questions = project.questions
          questions = [OpenStruct.new(id: 1, question: 'How old are you')]

          questions.map do |question|
            Entities::V1::ChartSource.new \
              id: question.id.to_s,
              value: question.question
          end
        end

        def allowed_sources
          self.class.allowed_sources(project_id)
        end

        def answers
          # @answers ||=
          #   ::Answer.where project_id: project_id, question_id: source.to_i
          []
        end

        def last_answer
          @last_answer ||= answers.last
        end

        def cached_answer_values_outdated?
          return cached_answer_updated_at.present? unless last_answer

          return true unless cached_answer_updated_at

          last_answer.updated_at > cached_answer_updated_at
        end
      end

    end
  end
end
