require 'aws-sdk'

module DashOverlord
  module Models
    module V1
      module DynamoDb
        class Migration < OpenStruct
          def initialize(migration_class)
            @client ||= Aws::DynamoDB::Client.new

            @migration_class = migration_class
          end

          def create!(params = nil)
            @client.create_table(params || create_params)
          end

          def create_params
            # THIS NEEDS TO BE DYNAMIC!
            {
              table_name: @migration_class.table_name,
              key_schema: [
                {
                  attribute_name: "dashboard_id",
                  key_type: "HASH" #PRIMARY KEY
                },
                {
                  attribute_name: "id",
                  key_type: "RANGE" # SORT KEY
                },
              ],
              attribute_definitions: [
                {
                  attribute_name: "dashboard_id",
                  attribute_type: "N"
                },
                {
                  attribute_name: "id",
                  attribute_type: "N"
                }
              ],
              provisioned_throughput: {
                read_capacity_units: 10,
                write_capacity_units: 10
              }
            }
          end

          def delete!
            @client.delete_table(delete_params)
          end

          def delete_params
            {
              table_name: @migration_class.table_name
            }
          end
        end
      end
    end
  end
end
