module DashOverlord
  module Serializers
    module V1
      module SubtitleLines

        class Show < SubtitleLines::Base
          expose :start_time, as: :start

          expose :end_time, as: :end

          expose :line

          expose :type_of_subtitle

          def start_time
            seconds_from(object.start_time)
          end

          def end_time
            return if object.tag?

            seconds_from(object.end_time)
          end

          private

          def seconds_from(time)
            time.hour * 60 + time.min
          end
        end

      end
    end
  end
end
