module DashOverlord
  module UseCases
    module V1
      module ChartConfigs
        module CacheAnswerValues

          class BuildCache < V1::Base
            context_reader :chart_config

            def perform
              chart_config.cached_answer_values =
                unique_answer_values.map { |key, value|
                  { label: key, value: value }
                }

              chart_config.cached_answer_updated_at = cached_answer_updated_at
            end

            protected

            def unique_answer_values
              case chart_config.function
              when 'count'
                calculate_values_occurences
              when 'percentage'
                calculate_values_percentage
              else
                raw_responses.each_with_object({}) do |raw_response, hash|
                  hash[raw_response.to_sym] = '-'
                end
              end
            end

            def cached_answer_updated_at
              return nil if chart_config.cached_answer_values.blank?

              # fucking Ebert, made me do this... fucker
              last_answer = chart_config.last_answer

              return DT.now if !last_answer || !last_answer.updated_at

              last_answer.updated_at
            end

            def calculate_values_occurences
              raw_responses.each_with_object({}) do |raw_response, hash|
                hash[raw_response] = hash[raw_response] ? (hash[raw_response] + 1) : 1
              end
            end

            def calculate_values_percentage
              hash = calculate_values_occurences

              total = hash.values.reduce(:+)

              hash.each do |key, occurences|
                hash[key] = (occurences * 100).to_f / total
              end

              hash
            end

            def raw_responses
              @raw_responses ||= chart_config.answers.map { |answer|
                Entities::Answer.new(answer.attributes).parsed_response
              }
            end

            private ########################## PRIVATE #############################

            def responses_vs_occurrences
              @responses_vs_occurrences ||=
                raw_responses.each_with_object({}) do |raw_response, hash|
                  hash[raw_response.to_sym] ||= []

                  hash[raw_response.to_sym] << 1
                end
            end
          end

        end
      end
    end
  end
end
