module DashOverlord
  module UseCases
    module V1
      module ChartConfigs
        module Create

          class AssignAttributesToChartConfig < V1::Base
            def perform
              context.chart_config.assign_attributes \
                chart_config_attributes
            end

            protected

            def chart_config_attributes
              (context.chart_config_attributes || {})
                .with_indifferent_access
                .slice \
                  :project_id,
                  :source,
                  :function,
                  :title,
                  :title_font_size,
                  :title_font_style,
                  :function_axis_title,
                  :function_axis_font_size,
                  :function_axis_font_style,
                  :function_axis_auto_adjust,
                  :function_axis_maximum,
                  :function_axis_minimum,
                  :function_axis_interval_auto_adjust,
                  :function_axis_interval,
                  :function_axis_labels_font_size,
                  :function_axis_labels_decimal_places,
                  :function_axis_labels_font_style,
                  :function_axis_labels_show,
                  :source_axis_options_order,
                  :source_axis_options_show,
                  :source_axis_font_size,
                  :source_axis_font_style
            end
          end

        end
      end
    end
  end
end
