module DashOverlord
  module UseCases
    module V1
      module ChartConfigs
        module Create

          class Base < V1::Base
            def perform
              invoke! Admins::FindCurrentAdmin
              invoke! BuildChartConfig
              invoke! AssignAttributesToChartConfig
              invoke! ValidateChartConfig
              # invoke! CacheAnswerValues::BuildCache
              invoke! SaveChartConfig

              status.created! if status.ok?
            end

            def final
              context.data = Serializers::V1::ChartConfigs::Create.to_hash \
                context,
                if status.created? || status.unprocessable_entity?
                  :chart_config
                else
                  false
                end
            end
          end

        end
      end
    end
  end
end
