module DashOverlord
  module UseCases
    module V1
      module ChartConfigs
        module Update

          class Base < V1::Base
            def perform
              invoke! Admins::FindCurrentAdmin
              invoke! Show::FindChartConfig
              invoke! Create::AssignAttributesToChartConfig
              invoke! Create::ValidateChartConfig
              # invoke! CacheAnswerValues::BuildCache
              invoke! SaveChartConfig
            end

            def final
              context.data = Serializers::V1::ChartConfigs::Update.to_hash \
                context,
                if status.ok? || status.unprocessable_entity?
                  :chart_config
                else
                  false
                end
            end
          end

        end
      end
    end
  end
end
