module DashOverlord
  module UseCases
    module V1
      module Clients
        module Create

          class ValidateClient < V1::Base
            target :client

            validates_presence_of :name

            def perform
              return if target_valid?

              failure! \
                :unprocessable_entity,
                I18n.t('v1.clients.contains_errors')
            end
          end

        end
      end
    end
  end
end
