module DashOverlord
  module UseCases
    module V1
      module DummyData
        module Create
          module Charts

            class Base < V1::Base
              context_reader :num_of_records, :repo, :table_name

              def perform
                return unless num_of_records && repo

                invoke! Charts::Build

                repository_create.perform \
                  items: context.items,
                  table_name: table_name
              end

              protected
              def repository_create
                [
                  "DashOverlord",
                  "UseCases",
                  "V1",
                  "Repositories",
                  repo.classify,
                  "Create",
                  "Batch"
                ].join('::').constantize
              end
            end
          end
        end
      end
    end
  end
end
