module DashOverlord
  module UseCases
    module V1
      module DummyData
        module Create
          module Charts
            class Build < V1::Base
              context_reader :num_of_records, :repo

              RECORD_STRUCTURE = {
                "gender" => ["Male", "Female"],
                "age" => ["0-8", "9-17", "18-30", "30-50", ">50"],
                "column_1" => :numeric,
                "column_2" => ["Sony", "Nintendo", "Sega", "Ubisoft", "Naughty Dog", "Electronic Arts"],
                "column_3" => :numeric,
                "column_4" => :numeric,
                "column_5" => :numeric,
                "column_6" => :numeric,
                "column_7" => :numeric,
                "column_8" => :numeric,
                "column_9" => :numeric,
                "column_10" => :numeric,
                "column_11" => :numeric,
                "column_12" => :numeric,
                "column_13" => :numeric
              }

              def perform
                context.items = build_dummy_data
              end

              protected ##########  PROTECTED #################################

              def build_dummy_data
                num_of_records.times.map do |index|
                  build_record(RECORD_STRUCTURE) \
                    .merge \
                      "id" => (index + 1),
                      "dashboard_id" => 1
                end
              end

              def build_value(type)
                if type.is_a?(Array)
                  type.sample
                elsif type == :numeric
                  rand(100)
                end
              end

              def build_record(structure)
                structure.each_with_object({}) do |(key, type), object|
                  object.merge! \
                    "#{key}" => build_value(type)
                end
              end

            end
          end
        end
      end
    end
  end
end
