require 'aws-sdk'

module DashOverlord
  module UseCases
    module V1
      module Repositories
        module DynamoDb
          class Client < V1::Base

            def perform
              context.client = build_dynamo_client
            end

            protected ################## PROTECTED #################

            def build_dynamo_client
              Aws::DynamoDB::Client.new(
                region: aws_region,
                credentials: aws_credentials,
                endpoint: "http://localhost:8000"
              )
            end

            def aws_region
              DashOverlord::V1::Config.get(:dynamodb_region)
            end

            def aws_credentials
              Aws::Credentials.new(
                DashOverlord::V1::Config.get(:dynamodb_access_key),
                DashOverlord::V1::Config.get(:dynamodb_secret_key)
              )
            end
          end
        end
      end
    end
  end
end
