module DashOverlord
  module UseCases
    module V1
      module Repositories
        module DynamoDb
          module Create

            class Batch < V1::Base
              context_reader :items,
                             :client,
                             :table_name

              def perform
                return unless items

                invoke! DynamoDb::Client

                create_batch
              end

              protected ################## PROTECTED #################

              def create_batch
                records.each_slice(25) do |batch|
                  client.batch_write_item \
                    request_items: {
                      "#{table_name}" => batch
                    }
                end
              end

              def records
                items.map do |item|
                  {
                    put_request: {
                      item: item
                    }
                  }
                end
              end
            end
          end
        end
      end
    end
  end
end
