module DashOverlord
  module UseCases
    module V1
      module Repositories
        module DynamoDb
          module SearchAndPaginate

            class Base < V1::Base

              # EXPECTED CONTEXT
              # :resource_class
              # :page
              # :per_page
              # :filter_query
              # :full_text_term

              def search_and_paginate(resource)
                context.resource = resource

                invoke! ApplyFilters

                # invoke! ApplyPagination
                puts "Before executing... #{DateTime.now}"
                context.resource = context.resource.execute
                puts "After executing... #{DateTime.now}"

                context.meta = Entities::V1::MetaData.new \
                  context.attributes.slice :page,
                                           :per_page,
                                           :total_pages,
                                           :total_results

                context.resource
              end
            end
          end
        end
      end
    end
  end
end