require 'ransack'

module DashOverlord
  module UseCases
    module V1
      module Shared
        module SearchAndPaginate

          class ApplyFilters < V1::Base
            context_reader :filter_query, :resources

            def perform
              return unless resources.respond_to?(:ransack)

              context.search_builder = resources.ransack(filter_query.presence)

              return unless context.search_builder.respond_to?(:result)

              context.resources = context.search_builder.result(distinct: true)
            end
          end

        end
      end
    end
  end
end
