module DashOverlord
  module UseCases
    module V1
      module Shared
        module SearchAndPaginate

          # EXPECTED CONTEXT
          # :resources
          # :page
          # :per_page
          # :filter_query
          # :full_text_term

          class Base < V1::Base
            def search_and_paginate(resources)
              context.resources = resources

              invoke! ApplyFullTextSearch
              invoke! ApplyFilters
              invoke! ApplyPagination
              invoke! ExecuteQuery
              invoke! BuildMetaData

              context.resources
            end
          end

        end
      end
    end
  end
end
