module DashOverlord
  module UseCases
    module V1
      module Shared
        module SearchAndPaginate

          class BuildMetaData < V1::Base
            context_reader :resources

            def perform
              context.total_pages ||= resources.total_pages
              context.total_results ||= resources.total_count

              context.meta = Entities::V1::MetaData.new \
                context.attributes.slice :page,
                                         :per_page,
                                         :total_pages,
                                         :total_results
            end
          end

        end
      end
    end
  end
end
