module DashOverlord
  module UseCases
    module V1
      module Users
        module Create

          class Base < V1::Base
            def perform
              invoke! Admins::FindCurrentAdmin
              invoke! BuildUser
              invoke! AssignAttributesToUser
              invoke! ValidateUser
              invoke! SaveUser

              status.created! if status.ok?
            end

            def final
              context.data = Serializers::V1::Users::Create.to_hash \
                context,
                status.created? || status.unprocessable_entity? ? :user : false
            end
          end

        end
      end
    end
  end
end
