module DashOverlord
  module UseCases
    module V1
      module Users
        module Create

          class ValidateUser < V1::Base
            target :user

            validates_presence_of :email

            validates_presence_of :password

            def perform
              return if target_valid?

              failure! \
                :unprocessable_entity,
                I18n.t('v1.users.contains_errors')
            end
          end

        end
      end
    end
  end
end
