module DashOverlord
  module UseCases
    module V1
      module Videos
        module Import
          module FromPostgresToElasticSearch

            class StoreBeeVideo < V1::Base
              context_reader :segment_uid, :postgres_bee_video

              def perform
                # results = DashOverlord::Models::V1::ElasticSearch::BeeVideo.by_dashboard('hhc').search

                Models::V1::ElasticSearch::BeeVideo
                  .by_dashboard(segment_uid)
                  .create bee_video_attributes
              end

              def bee_video_attributes
                attributes = postgres_bee_video.attributes.dup

                attributes.delete(:extra)

                attributes.merge!(postgres_bee_video.extra || {})

                attributes[:title] = "#{attributes['country']}, #{attributes['category']}"

                attributes
              end
            end

          end
        end
      end
    end
  end
end
