module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index

          class Base < V1::Base
            DEFAULT_SEARCH_ADAPTER_USE_CASE = ElasticSearch::Base

            def perform
              invoke! Users::FindCurrentUser
              invoke! search_adapter_use_case
            end

            def final
              context.data = Serializers::V1::Videos::Index.to_hash \
                context, status.ok? ? nil : false
            end

            protected

            def search_adapter_use_case
              context.search_adapter_use_case || DEFAULT_SEARCH_ADAPTER_USE_CASE
            end
          end

        end
      end
    end
  end
end
