module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index
          module ElasticSearch

            class SearchAndPaginateVideos < Shared::SearchAndPaginate::Base
              context_reader :segment_uid

              def perform
                context.videos = search_and_paginate bee_videos
              end

              protected

              def bee_videos
                Models::V1::ElasticSearch::BeeVideo
                  .by_dashboard(segment_uid)
                  .none
              end
            end

          end
        end
      end
    end
  end
end
