module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index
          module Postgres

            class BuildVideoSearchedLines < V1::Base
              context_reader :videos,
                             :subtitle_lines

              def perform
                context.videos = videos.map do |video|
                  video.meta = {
                    searched_lines: searched_lines_for(video.id)
                  }

                  video
                end
              end

              private

              def searched_lines_for(video_id)
                return [] if subtitle_lines.nil?

                subtitle_lines
                  .select{|line| line.bee_video_id == video_id}
                  .map{|line| serialize_searched_line(line)}
              end

              def serialize_searched_line(line)
                Serializers::V1::SubtitleLines::Show.to_hash(line)
              end
            end

          end
        end
      end
    end
  end
end
