module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index
          module Postgres

            class GetFilters < V1::Base
              def perform
                filters = {
                  'hhc' => hhc,
                  'laundry' => laundry,
                  'world_cuisine' => world_cuisine
                }

                context.meta.assign_attributes filters[context.segment_uid] || {}
              end

              def hhc
                JSON.parse(File.read(File.expand_path('../hhc.json', __FILE__)))
              end

              def laundry
                {
                  filters: [
                    {
                      name: 'country',
                      title: 'Country',
                      options: [
                        { value: 'South Africa', label: 'South Africa' },
                        { value: 'Nigeria', label: 'Nigeria' },
                        { value: 'Kenya', label: 'Kenya' }
                      ]
                    },
                    {
                      name: 'category',
                      title: 'Category',
                      options:[
                        { value: 'Brands', label: 'Brands' },
                        { value: 'Laundry', label: 'Laundry' },
                        { value: 'Doing Laundry', label: 'Doing Laundry' }
                      ]
                    }
                  ]
                }
              end

              def world_cuisine
                {
                  filters: [
                    {
                      name: 'country',
                      title: 'Country',
                      options: [
                        { value: 'South Africa', label: 'South Africa' },
                        { value: 'India', label: 'India' },
                        { value: 'Brazil', label: 'Brazil' }
                      ]
                    },
                    {
                      name: 'category',
                      title: 'Category',
                      options:[
                        { value: 'Serving', label: 'Serving' },
                        { value: 'Cooking', label: 'Cooking' },
                        { value: 'Pre-cooking', label: 'Pre-cooking' }
                      ]
                    },
                    {
                      name: 'cuisine',
                      title: 'Cuisine',
                      options:[
                        { value: 'Chinese', label: 'Chinese' },
                        { value: 'Italian', label: 'Italian' },
                        { value: 'Thai', label: 'Thai' },
                        { value: 'Indian', label: 'Indian' }
                      ]
                    }
                  ]
                }
              end

            end

          end
        end
      end
    end
  end
end
