module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index
          module Postgres

            class SearchAndPaginateVideos < Shared::SearchAndPaginate::Base
              context_reader :subtitle_lines, :segment_uid

              def perform
                context.videos = search_and_paginate bee_videos
              end

              protected

              def bee_videos
                scope = Models::V1::BeeVideo
                  .where(rejected_by_system: false)
                  .where(segment_uid: segment_uid)
                  .includes(:subtitle_lines)

                return scope if subtitle_lines.blank?

                scoped_bee_videos_ids = subtitle_lines.map(&:bee_video_id).uniq

                scope.where(id: scoped_bee_videos_ids)
              end
            end

          end
        end
      end
    end
  end
end
