module DashOverlord
  module UseCases
    module V1
      module Videos
        module Index
          module Postgres

            class SearchOnSubtitleLines < V1::Base
              context_reader :full_text_term, :segment_uid

              def perform
                return if full_text_term.blank?

                context.subtitle_lines =
                  Models::V1::SubtitleLine
                    .order(:start_time)
                    .where(segment_uid: segment_uid)
                    .ft(full_text_term)
              end
            end

          end
        end
      end
    end
  end
end
