require 'forwardable'
require 'elasticsearch'

require_relative 'elasticord/base'
require_relative 'elasticord/config'
require_relative 'elasticord/version'

module Elasticord
  def self.elastic_search_client
    @elastic_search_client ||= reset_elastic_search_client
  end

  def self.reset_elastic_search_client
    @elastic_search_client = Elasticsearch::Client.new \
      log: Elasticord::Config.get(:log)
  end

  def self.configure
    yield(Config)
  end
end
