module Elasticord
  module Client
    class ArrayWithMetaData < SimpleDelegator
      attr_accessor :per_page, :current_page, :total_results

      def initialize(page_default, per_page_default)
        @internal_array = []

        @per_page = per_page_default
        @current_page = page_default
        @total_results = 0

        super(@internal_array)
      end

      alias total_count total_results

      def total_pages
        (total_results / per_page.to_f).ceil
      end

      def size
        per_page
      end

      def from
        (current_page - 1) * size
      end
    end
  end
end
