module Elasticord
  module Client
    module Create
      module_function

      REFRESH_INDEX_AFTER_CREATE = true

      def one(elastic_search_client, index, type, attributes = {})
        params = build_params(index, type, attributes)

        begin
          elastic_search_client.index params
        rescue Elasticsearch::Transport::Transport::Errors::Conflict
          return false
        end
      end

      def build_params(index, type, attributes)
        params = {
          type: type,
          body: attributes,
          index: index,
          refresh: REFRESH_INDEX_AFTER_CREATE
        }

        params[:id] = attributes[:id] if attributes[:id]

        params
      end
    end
  end
end
